#include <QTRSensors.h>
QTRSensors qtr;
#define centerleftsensor A0
#define centerrightsensor A3
#define nearleftsensor A1
#define nearrightsensor A4
#define farleftsensor A2
#define farrightsensor A5
int centerleftreading;
int centerrightreading;
int nearleftreading;
int nearrightreading; 
int farleftreading;
int farrightreading;

#define leftMotor1 11
#define leftMotor2 12
#define rightMotor1 6
#define rightMotor2 8
#define leftMotorEn 10 
#define rightMotorEn 9
   int x = 0;
 int x1 = 0;
 int x2 = 0;
 int x3 = 0;
 int x4 = 0;
 int x5 = 0;




const uint8_t SensorCount = 6;
uint16_t sensorValues[SensorCount];

void setup()
{

pinMode(leftMotor1, OUTPUT);
pinMode(leftMotor2, OUTPUT);
pinMode(rightMotor1, OUTPUT);
pinMode(rightMotor2, OUTPUT);
pinMode(leftMotorEn, OUTPUT);
pinMode(rightMotorEn, OUTPUT);
analogWrite(leftMotorEn, 80);
analogWrite(rightMotorEn, 80);
  qtr.setTypeAnalog();
  qtr.setSensorPins((const uint8_t[]){A0, A1, A2, A3, A4, A5}, SensorCount);
  qtr.setEmitterPin(2);

  delay(100);
// turn on Arduino's LED to indicate we are in calibration mode

  // analogRead() takes about 0.1 ms on an AVR.
  // 0.1 ms per sensor * 4 samples per sensor read (default) * 6 sensors
  // * 10 reads per calibrate() call = ~24 ms per calibrate() call.
  // Call calibrate() 400 times to make calibration take about 10 seconds.
  for (uint16_t i = 0; i < SensorCount; i++)
  {
    qtr.calibrate();
  }
  Serial.begin(9600);
}

void loop()
{


  int x = 0;
  qtr.read(sensorValues);

  // print the sensor values as numbers from 0 to 1023, where 0 means maximum
  // reflectance and 1023 means minimum reflectance
  for (uint8_t i = 0; i < SensorCount; i++)
  {
   
    if(sensorValues[0] > 1000)
     x = 0;
    
     else
      x = 1;   
    
  
   
  
        if(sensorValues[1] > 1000)
     x1 = 0;
    
     else
      x1 = 1;   
    
    
   

        if(sensorValues[2] > 1000)
     x2 = 0;
    
     else
      x2 = 1;   
    
   
   
 
        if(sensorValues[3] > 1000)
     x3 = 0;
    
     else
      x3 = 1;   
    

   
 
        if(sensorValues[4] > 1000)
     x4 = 0;
    
     else
      x4 = 1;   
    
 
   

        if(sensorValues[5] > 1000)
     x5 = 0;
    
     else
      x5 = 1;   
  }
    {  centerrightreading= (x);
  farleftreading =(x2);
  nearleftreading = (x1);
  centerleftreading = (x3);
  nearrightreading = (x4);
    farrightreading = (x5);
    Serial.print(centerrightreading);
    Serial.print(farleftreading);
        Serial.print(nearleftreading);
    Serial.print(centerleftreading);
        Serial.print(nearrightreading);
    Serial.println(farrightreading);
    }
  

  

   
  if  (centerleftreading==0 && centerrightreading==0 && nearleftreading==1 && nearrightreading == 1 && farleftreading ==1 && farrightreading == 1) 
  {
straight();
  }
 
  if(centerrightreading == 0 && centerleftreading ==0 && nearleftreading == 0 && nearrightreading == 1 || nearrightreading == 0 && farleftreading == 0 || farleftreading == 1 && farrightreading == 1) 
  {
 
turnLeft();
   }
   if (centerrightreading == 0 && centerleftreading ==0 && nearrightreading == 0 && nearleftreading == 1 || nearleftreading == 0 && farrightreading == 0 || farrightreading == 1 && farleftreading == 1){
     turnRight();
   }
   if (centerrightreading ==1 && centerleftreading == 1 && nearrightreading ==1 && nearleftreading == 1){
     turnAround();
   }

}


  void straight(){
if((centerleftreading)==1){
digitalWrite(leftMotor1, HIGH);
digitalWrite(leftMotor2, LOW);
digitalWrite(rightMotor1, HIGH);
digitalWrite(rightMotor2, LOW);
delay(1);
digitalWrite(leftMotor1, HIGH);
digitalWrite(leftMotor2, LOW);
digitalWrite(rightMotor1, LOW);          
digitalWrite(rightMotor2, HIGH);
delay(2);
return;
}
if((centerrightreading)==1){
digitalWrite(leftMotor1, HIGH);
digitalWrite(leftMotor2, LOW);
digitalWrite(rightMotor1, HIGH);
digitalWrite(rightMotor2, LOW);
delay(1);
digitalWrite(leftMotor1, LOW);
digitalWrite(leftMotor2, HIGH);
digitalWrite(rightMotor1, HIGH);
digitalWrite(rightMotor2, LOW);
delay(2);
return;
}
digitalWrite(leftMotor1, HIGH);
digitalWrite(leftMotor2, LOW);
digitalWrite(rightMotor1, HIGH);
digitalWrite(rightMotor2, LOW);
delay(2);

}
void turnLeft(){
while((centerrightreading)==0||(centerrightreading)==1){
digitalWrite(leftMotor1, LOW);
digitalWrite(leftMotor2, HIGH);
digitalWrite(rightMotor1, HIGH);
digitalWrite(rightMotor2, LOW);
delay(20);
digitalWrite(leftMotor1, LOW);
digitalWrite(leftMotor2, LOW);
digitalWrite(rightMotor1, LOW);
digitalWrite(rightMotor2, LOW);
delay(10);
}

}
void turnRight(){
while((centerleftreading)==0 ||(centerleftreading)==1){
digitalWrite(leftMotor1, HIGH);
digitalWrite(leftMotor2, LOW);
digitalWrite(rightMotor1, LOW);
digitalWrite(rightMotor2, HIGH);
delay(20);
digitalWrite(leftMotor1, LOW);
digitalWrite(leftMotor2, LOW);
digitalWrite(rightMotor1, LOW);
digitalWrite(rightMotor2, LOW);
delay(10);
}


}
void turnAround(){
digitalWrite(leftMotor1, HIGH);
digitalWrite(leftMotor2, LOW);
digitalWrite(rightMotor1, HIGH);
digitalWrite(rightMotor2, LOW);
delay(150);
while((centerleftreading)==1){
digitalWrite(leftMotor1, LOW);
digitalWrite(leftMotor2, HIGH);
digitalWrite(rightMotor1, HIGH);
digitalWrite(rightMotor2, LOW);
delay(2);
digitalWrite(leftMotor1, LOW);
digitalWrite(leftMotor2, LOW);
digitalWrite(rightMotor1, LOW);
digitalWrite(rightMotor2, LOW);
delay(1);
}
}